=== debian/changelog ===
quaternion (0.0.5-1) unstable; urgency=medium

  * New upstream release
  * Updated copyright file

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 23 Dec 2017 08:33:05 -0500

quaternion (0.0.1+git20170607.121b251-1) unstable; urgency=medium

  * Initial release (Closes: #864375)

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 30 Aug 2017 08:48:48 -0400
