=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9), cmake, qtbase5-dev (>= 5.2.1), qtdeclarative5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/QMatrixClient/Quaternion
Vcs-Git: git://anonscm.debian.org/collab-maint/quaternion.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/quaternion.git

Package: quaternion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.
