=== debian/changelog ===
quaternion (0.0.9.2-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 09 Jul 2018 10:56:40 -0400

quaternion (0.0.9.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules: don't install dev files. (Closes: #898376)
  * debian/control: set maintainer to team.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 16 May 2018 00:10:17 -0400

quaternion (0.0.9-1) unstable; urgency=medium

  * New upstream release

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 03 May 2018 13:43:06 -0400

quaternion (0.0.5-2) unstable; urgency=medium

  * debian/control:
    * depend on qtquick controls (Closes: #896093)
    * update vcs fields to point to the right location

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 24 Apr 2018 11:12:56 -0400
