=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# remove development files
	rm -rf $(CURDIR)/debian/quaternion/usr/include $(CURDIR)/debian/quaternion/usr/lib $(CURDIR)/debian/quaternion/usr/bin/qmc-example

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../quaternion_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /lib -C .. `basename $(CURDIR)`
	tar czf ../quaternion_$(VERSION).orig-lib.tar.gz --exclude-vcs --exclude-backups lib
