=== debian/changelog ===
quaternion (0.0.9.3-1) unstable; urgency=medium

  * New upstream release (Closes: #913717).
  * debian/control: depend on libqmatrixclient-dev and qttools5-dev.
  * debian/rules: remove unnecessary rules
  * debian/README.source: remove, since libqmatrixclient is no longer bundled.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 01 Jan 2019 10:34:02 -0500
