=== debian/control ===
--- 
+++ 
@@ -3,7 +3,12 @@
 Priority: optional
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
-Build-Depends: debhelper (>=9), cmake, qtbase5-dev (>= 5.2.1), qtdeclarative5-dev
+Build-Depends: cmake
+ , debhelper (>=9)
+ , libqmatrixclient-dev (>= 0.4.0)
+ , qtbase5-dev (>= 5.2.1)
+ , qtdeclarative5-dev
+ , qttools5-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/QMatrixClient/Quaternion
 Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
