## quaternion 0.0.9.4c

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
 
-project(quaternion CXX)
+set(IDENTIFIER "com.github.quaternion")
+set(COPYRIGHT "Copyright © 2018-2019 QMatrixClient Project")
+
+project(quaternion VERSION 0.0.9.4 LANGUAGES CXX)
 
 if(UNIX AND NOT APPLE)
     set(LINUX 1)
@@ -37,11 +40,25 @@
 endforeach ()
 
 # Find the libraries
-find_package(Qt5 5.6 REQUIRED Widgets Network Quick Qml QuickWidgets Gui LinguistTools)
+find_package(Qt5 5.7 REQUIRED Widgets Network Quick Qml Gui LinguistTools Multimedia DBus)
+# Qt5_Prefix is only used to show Qt path in message()
+# Qt5_BinDir is where all the binary tools for Qt are
+if (QT_QMAKE_EXECUTABLE)
+    get_filename_component(Qt5_BinDir "${QT_QMAKE_EXECUTABLE}" DIRECTORY)
+    get_filename_component(Qt5_Prefix "${Qt5_BinDir}/.." ABSOLUTE)
+else()
+    get_filename_component(Qt5_BinDir "${Qt5_DIR}/../../../bin" ABSOLUTE)
+    get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
+endif()
 if (USE_QQUICKWIDGET)
-    find_package(Qt5 5.6 REQUIRED QuickWidgets)
-endif()
-get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
+    find_package(Qt5 5.7 REQUIRED QuickWidgets)
+elseif(NOT DISABLE_QQUICKWIDGET)
+    # QQuickWidget only stopped crashing in Qt 5.12, use it by default if found
+    find_package(Qt5 5.12 QUIET COMPONENTS QuickWidgets)
+    if (Qt5QuickWidgets_FOUND)
+        set(USE_QQUICKWIDGET ON)
+    endif()
+endif()
 
 if(WIN32)
     enable_language(RC)
@@ -53,18 +70,28 @@
     endif()
 endif()
 
-if (USE_INTREE_LIBQMC)
+if ((NOT DEFINED USE_INTREE_LIBQMC OR USE_INTREE_LIBQMC)
+        AND EXISTS ${PROJECT_SOURCE_DIR}/lib/lib/util.h)
     add_subdirectory(lib EXCLUDE_FROM_ALL)
     include_directories(lib)
-else ()
-    find_package(QMatrixClient 0.4 REQUIRED)
+    if (NOT DEFINED USE_INTREE_LIBQMC)
+        set (USE_INTREE_LIBQMC 1)
+    endif ()
+endif ()
+if (NOT USE_INTREE_LIBQMC)
+    find_package(QMatrixClient 0.5.1 REQUIRED)
     if (NOT QMatrixClient_FOUND)
         message( WARNING "libQMatrixClient not found; configuration will most likely fail.")
         message( WARNING "Make sure you have installed libQMatrixClient development files")
-        message( WARNING "or pass -DUSE_INTREE_LIBQMC to CMake if you're using the library")
-        message( WARNING "as a Git submodule in lib/. See also BUILDING.md")
+        message( WARNING "as a package or checked out the library sources in lib/.")
+        message( WARNING "See also BUILDING.md")
     endif ()
 endif ()
+
+find_package(Qt5Keychain QUIET)
+if (Qt5Keychain_FOUND)
+    set(USE_KEYCHAIN ON)
+endif()
 
 message( STATUS )
 message( STATUS "=============================================================================" )
@@ -102,6 +129,9 @@
 if (USE_QQUICKWIDGET)
     message( STATUS "Using QQuickWidget to render QML")
 endif(USE_QQUICKWIDGET)
+if (USE_KEYCHAIN)
+    message( STATUS "Using Qt5Keychain ${Qt5Keychain_VERSION} at ${Qt5Keychain_DIR}")
+endif ()
 message( STATUS "=============================================================================" )
 message( STATUS )
 
@@ -124,6 +154,8 @@
     client/models/messageeventmodel.cpp
     client/models/userlistmodel.cpp
     client/models/roomlistmodel.cpp
+    client/models/abstractroomordering.cpp
+    client/models/orderbytag.cpp
     client/main.cpp
     )
 
@@ -131,38 +163,71 @@
     client/resources.qrc
     )
 
+# quaternion_en.ts is updated explicitly by building trbase target,
+# while all other translation files are created and updated externally at
+# Lokalise.co
+set(quaternion_en_TS client/translations/quaternion_en.ts)
+QT5_CREATE_TRANSLATION(client/translations ${quaternion_SRCS} ${quaternion_QRC} ${quaternion_en_TS})
+add_custom_target(trbase SOURCES ${quaternion_en_TS} VERBATIM)
+
 set(quaternion_TS
-    client/translations/quaternion_en.ts
+    client/translations/quaternion_en_GB.ts
     client/translations/quaternion_de_DE.ts
-    )
+    client/translations/quaternion_pl.ts
+    client/translations/quaternion_ru.ts
+    )
+QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
 
 QT5_ADD_RESOURCES(quaternion_QRC_SRC ${quaternion_QRC})
 set_property(SOURCE qrc_resources.cpp PROPERTY SKIP_AUTOMOC ON)
 
-QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
-QT5_CREATE_TRANSLATION(client/translations ${quaternion_SRCS} ${quaternion_QRC} ${quaternion_TS})
-
 if(WIN32)
-    set(quaternion_WINRC ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc)
-    set_property(SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc
-        APPEND PROPERTY OBJECT_DEPENDS
-            ${CMAKE_CURRENT_SOURCE_DIR}/icons/quaternion.ico
-    )
-endif()
+    set(quaternion_WINRC quaternion_win32.rc)
+    set_property(SOURCE quaternion_win32.rc APPEND PROPERTY
+        OBJECT_DEPENDS ${PROJECT_SOURCE_DIR}/icons/quaternion.ico
+    )
+endif()
+
+if(APPLE)
+    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
+    set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
+
+    set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
+
+    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${quaternion_VERSION})
+    set(MACOSX_BUNDLE_BUNDLE_VERSION ${quaternion_VERSION})
+
+    set(ICON_NAME "quaternion.icns")
+    set(${PROJECT_NAME}_MAC_ICON "${PROJECT_SOURCE_DIR}/icons/${ICON_NAME}")
+    set(MACOSX_BUNDLE_ICON_FILE ${ICON_NAME})
+    set_property(SOURCE "${${PROJECT_NAME}_MAC_ICON}" PROPERTY
+        MACOSX_PACKAGE_LOCATION Resources)
+endif(APPLE)
 
 # Windows, this is a GUI executable; OSX, make a bundle
-add_executable(quaternion WIN32 MACOSX_BUNDLE ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_WINRC} ${quaternion_QM})
-
-target_link_libraries(quaternion QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
-target_compile_definitions(quaternion PRIVATE GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
+add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
+    ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_QM}
+    ${quaternion_WINRC} ${${PROJECT_NAME}_MAC_ICON})
+
+target_link_libraries(${PROJECT_NAME}
+    QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
+target_compile_definitions(${PROJECT_NAME} PRIVATE
+    GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
 
 if (USE_QQUICKWIDGET)
-    target_compile_definitions(quaternion PRIVATE USE_QQUICKWIDGET)
-    target_link_libraries(quaternion Qt5::QuickWidgets)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_QQUICKWIDGET)
+    target_link_libraries(${PROJECT_NAME} Qt5::QuickWidgets)
+endif()
+
+if(USE_KEYCHAIN)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_KEYCHAIN)
+    target_link_libraries(${PROJECT_NAME} ${QTKEYCHAIN_LIBRARIES})
+    include_directories(${QTKEYCHAIN_INCLUDE_DIR})
 endif()
 
 # macOS specific config for bundling
-set_target_properties(quaternion PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
+set_property(TARGET ${PROJECT_NAME} PROPERTY
+    MACOSX_BUNDLE_INFO_PLIST "${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
 
 # Installation
 
@@ -170,14 +235,14 @@
     set(CMAKE_INSTALL_BINDIR ".")
 endif()
 
-install(TARGETS quaternion
+install(TARGETS ${PROJECT_NAME}
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
         BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
 if(LINUX)
-    install(FILES linux/quaternion.desktop
+    install(FILES linux/${IDENTIFIER}.desktop
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/applications
             )
-    install(FILES linux/com.github.quaternion.appdata.xml
+    install(FILES linux/${IDENTIFIER}.appdata.xml
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
             )
     install(FILES ${quaternion_QM}
@@ -189,35 +254,39 @@
                       )
 endif(LINUX)
 
+set(QML_DIR ${PROJECT_SOURCE_DIR}/client/qml)
+if (NOT DEPLOY_VERBOSITY)
+    set(DEPLOY_VERBOSITY 1) # The default for *deployqt tools, out of 0..3
+endif()
 if(WIN32)
-    if (${Qt5_VERSION} VERSION_LESS "5.3")
-        install(CODE "
-            message(\"Deploying on Windows is only supported with Qt 5.3 or higher\")
-            message(\"Bare executable has been copied to the target folder\")
-        ")
-    else()
-        get_filename_component(Qt5_WinBaseDir "${Qt5_DIR}/../../.." ABSOLUTE)
-        install(CODE "
-            if (CMAKE_INSTALL_CONFIG_NAME STREQUAL \"Debug\")
-                set(WDQ_FLAG debug)
-            else()
-                set(WDQ_FLAG release)
-            endif()
-            execute_process(
-                COMMAND bin/windeployqt --\${WDQ_FLAG} --no-system-d3d-compiler --no-opengl
-                    --no-multimedia --no-multimediaquick --no-declarative --no-test \
-                    --qmldir qml \"\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}\"
-                WORKING_DIRECTORY \"${Qt5_WinBaseDir}\"
-                RESULT_VARIABLE WDQ_RETVAL
-            )
-            if (WDQ_RETVAL)
-                message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
-            else()
-                message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
-            endif()
-        ")
-        install(FILES ${quaternion_QM}
-                DESTINATION ${CMAKE_INSTALL_BINDIR}/translations
-               )
-    endif()
+    install(CODE "
+        message(STATUS \"Running windeployqt at \${CMAKE_INSTALL_PREFIX}\${CMAKE_INSTALL_BINDIR}\")
+        execute_process(
+            COMMAND \"${Qt5_BinDir}/windeployqt\" --verbose ${DEPLOY_VERBOSITY}
+                --no-multimediaquick --no-declarative --no-test --no-winextras
+                --qmldir \"${QML_DIR}\"
+                \${CMAKE_INSTALL_PREFIX}\${CMAKE_INSTALL_BINDIR}
+            RESULT_VARIABLE WDQ_RETVAL
+        )
+        if (WDQ_RETVAL)
+            message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
+        else()
+            message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
+        endif()
+    ")
+    install(FILES ${quaternion_QM}
+            DESTINATION ${CMAKE_INSTALL_BINDIR}/translations
+           )
 endif(WIN32)
+
+# Packaging
+
+if(APPLE)
+    set(MACDEPLOYQT_ARGS ${PROJECT_NAME}.app -dmg -qmldir="${QML_DIR}" -verbose=${DEPLOY_VERBOSITY})
+    add_custom_target(image
+        COMMAND "${Qt5_BinDir}/macdeployqt" ${MACDEPLOYQT_ARGS}
+        DEPENDS ${PROJECT_NAME}
+        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
+        COMMENT "Running ${MACDEPLOYQT} with args: ${MACDEPLOYQT_ARGS}"
+    )
+endif(APPLE)
