=== debian/changelog ===
quaternion (0.0.9.4c-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:24:08 +0100

quaternion (0.0.9.4c-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: build-depend on qt5keychain-dev

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 25 Jun 2019 21:59:11 -0400
