=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: cmake
 , debhelper (>=10)
 , libqmatrixclient-dev (>= 0.5.0)
 , qt5keychain-dev
 , qtbase5-dev
 , qtdeclarative5-dev
 , qtmultimedia5-dev
 , qttools5-dev
Standards-Version: 4.3.0
Homepage: https://github.com/quotient-im/Quaternion
Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git

Package: quaternion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qtquick-controls, qml-module-qtquick-controls2
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.
