=== debian/changelog ===
quaternion (0.0.9.4e-1) unstable; urgency=medium

  * New upstream version.
  * Build with newer libqmatrixclient.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 17 Apr 2020 22:25:00 -0400
