=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
 Build-Depends: cmake
- , debhelper (>=10)
- , libqmatrixclient-dev (>= 0.5.0)
+ , debhelper-compat (=12)
+ , libqmatrixclient-dev (>= 0.5.3.2)
  , qt5keychain-dev
  , qtbase5-dev
  , qtdeclarative5-dev
