=== debian/changelog ===
quaternion (0.0.9.5~beta2-2) unstable; urgency=medium

  * Add upstream patches to fix crashes and rendering issues.  (Closes: #983707)

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 01 Mar 2021 16:46:15 -0500

quaternion (0.0.9.5~beta2-1) unstable; urgency=medium

  * New upstream beta.
  * Build with libquotient instead of libqmatrixclient. (Closes: #980651)

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 22 Jan 2021 17:16:02 -0500
