=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Hubert Chathi <uhoreg@debian.org>
 Build-Depends: cmake
  , debhelper-compat (=12)
- , libqmatrixclient-dev (>= 0.5.3.2)
+ , libquotient-dev (>= 0.6.4)
  , qt5keychain-dev
  , qtbase5-dev
  , qtdeclarative5-dev
  , qtmultimedia5-dev
  , qttools5-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/quotient-im/Quaternion
 Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
 Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git
